//#define __USE_GTK3__

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "string.h"
#include "keys.h"

/*
#include "dir.bi"

#include Once "gtk/gtk.bi"

#include Once "crt/stdio.bi"

#include Once "crt/string.bi" 

#include Once "crt/stdlib.bi"

#include Once "zlib.bi"

#include Once "X11/Xlib.bi"

#include Once "GL/gl.bi"

#include Once "GL/glu.bi"

#include Once "extwstring.bi"

*/

using namespace fbc;

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

#define FBNORMAL 0x21
#define FBDIRECTORY 0x10
#define Integer32 int
#define BGR(r, g, b) (int)(((unsigned char)(r) | (( (short int) ((unsigned char)g)) << 8)) | (((int) ((unsigned char)b)) << 16))
#define MAKELONG(a, b) ((int) (((short int) (a)) | ((int) ((short int) (b))) << 16)) 
#define FILE_BEGIN SEEK_SET
#define FILE_CURRENT SEEK_CUR
#define FILE_END SEEK_END
#define TBS_HORZ 0
#define TBS_VERT 2
#define WS_POPUP	0x80000000
#define WS_VISIBLE	0x10000000
#define WS_OVERLAPPEDWINDOW	0xCF0000
#define WS_MAXIMIZE	0x1000000
#define WS_MINIMIZE	0x20000000
#define WS_VSCROLL 0x00200000
#define WS_HSCROLL 0x00100000
#define FB_BS_PUSHLIKE  0x00001000
#define BS_ICON 0
#define BS_BITMAP 0
#define SS_CENTER 1
#define SS_RIGHT 2
#define SS_LEFT 0
#define SS_NOTIFY 256
#define ES_LEFT 0
#define ES_CENTER 1
#define ES_RIGHT 2
#define ES_PASSWORD 0x0020
#define ES_READONLY 0x0800
#define ES_NUMBER 0x2000
#define UDS_WRAP 1
#define OFN_ALLOWMULTISELECT 0x200
#define OFN_DIRECTORY 0x400
#define LBS_EXTENDEDSEL 0x0800
#define LBS_SORT 0x0002
#define LVS_NOCOLUMNHEADER 0x4000
#define LVS_SINGLESEL 0x4
#define LVS_EX_GRIDLINES 0x1
#define LVIF_TEXT 1
#define LVIF_IMAGE 2
#define LVIS_SELECTED 1
#define LVIS_FOCUSED 1
#define TVI_FIRST 0
#define TVI_LAST -1
#define PBS_SMOOTH 1
#define PBS_VERTICAL 4
#define PBS_MARQUEE 8
#define SBS_HORZ 0
#define SBS_VERT 1
#define MB_OK 0
#define MB_YESNO 4
#define MB_YESNOCANCEL 3
#define IDOK 1
#define IDYES 6
#define IDNO 7
#define IDCANCEL 2
#define FB_IGNORE 999999
#define CC_RGBINIT 1
#define EVENTGADGET 0x401
#define EVENTMENU  0x402
#define EVENTCLOSE 0x10
#define EVENTMOUSEMOVE  0x200
#define EVENTMOUSEWHEEL 0x20A
#define EVENTACTIVATE 0x6
#define EVENTSIZE     0x5
#define EVENTMOVE     0x3
#define EVENTKEYDOWN 0x100
#define EVENTKEYUP   0x101
#define EVENTLBDOWN   0x201
#define EVENTLBUP     0x202
#define EVENTRBDOWN   0x204
#define EVENTRBUP     0x205
#define EVENTMBDOWN   0x207
#define EVENTMBUP     0x208
#define EVENTDBLCLICK 0x209
#define EVENTTIMER 0x113
#define EVENTNUMBERTREEVIEW EVENTNUMBERLISTVIEW
#define EVENTNUMBERTOOLBAR EVENTNUMBER
#define MK_SHIFT GDK_SHIFT_MASK
#define MK_CONTROL GDK_CONTROL_MASK
#define MK_LBUTTON GDK_BUTTON1_MASK
#define MK_MBUTTON GDK_BUTTON2_MASK
#define MK_RBUTTON GDK_BUTTON3_MASK
#define FILE_ATTRIBUTE_HIDDEN 0x02
#define FILE_ATTRIBUTE_ARCHIVE 0x20
#define FILE_ATTRIBUTE_DIRECTORY 0x10
#define FILE_ATTRIBUTE_READONLY 0x01
#define FILE_ATTRIBUTE_SYSTEM 0x04
#define TBSTYLE_TOOLTIPS 0x100
#define SBT_TOOLTIPS 0x800
#define STD_CUT 0
#define STD_COPY 1
#define STD_PASTE 2
#define STD_UNDO 3
#define STD_REDOW 4
#define STD_DELETE 5
#define STD_FILENEW 6
#define STD_FILEOPEN 7
#define STD_FILESAVE 8
#define STD_PRINTPRE 9
#define STD_PROPERTIES 10
#define STD_HELP 11
#define STD_FIND 12
#define STD_REPLACE 13
#define STD_PRINT 14
#define TBSTYLE_BUTTON 0x0
#define TBSTYLE_CHECK 0x2
#define TBSTATE_CHECKED 0x1
#define TBSTATE_ENABLED 0x4
#define TBSTATE_HIDDEN 0x8
#define TBSTATE_INDETERMINATE 0x10
#define IDB_STD_SMALL_COLOR 1
#define IDB_STD_LARGE_COLOR 2
#define WS_TABSTOPENABLE 0
#define PS_SOLID 0
#define PS_DASH 1
#define PS_DOT 2
#define PS_DASHDOT 3
#define PS_DASHDOTDOT 4
#define PS_NULL 5
#define ANTIALIAS_NONE CAIRO_ANTIALIAS_NONE
#define ANTIALIAS_FAST CAIRO_ANTIALIAS_FAST
#define ANTIALIAS_GOOD CAIRO_ANTIALIAS_GOOD
#define ANTIALIAS_BEST CAIRO_ANTIALIAS_BEST

enum W9WRAPMODE
{
	WRAPMODETILE,
	WRAPMODETILEFLIPX,
	WRAPMODETILEFLIPY,
	WRAPMODETILEFLIPXY,
	WRAPMODECLAMP
};

enum W9FONTSTYLE
{	
	FONTSTYLEREGULAR = 0,
	FONTSTYLEBOLD = 1,
	FONTSTYLEITALIC = 2,
	FONTSTYLEBOLDITALIC = 3,
	FONTSTYLEUNDERLINE = 4,
	FONTSTYLESTRIKEOUT = 8,
};

enum W9UNIT
{	
	UNITWORLD,
	UNITDISPLAY,
	UNITPIXEL,
	UNITPOINT,
	UNITINCH,
	UNITDOCUMENT,
	UNITMILLIMETER
};

typedef GtkWidget* HWND;

typedef GdkPixbuf* HBITMAP;

typedef FILE* HANDLE;

typedef void* HMENU;

typedef void* HDC;

extern "C"
{

	// ------------------------------------------window
	HWND OPENWINDOW (fbstring* sName , int x , int y , int w , int h , int style = WS_OVERLAPPEDWINDOW | WS_VISIBLE , int style2 = 0 , void* User_data_Sub = 0);
	void CENTERWINDOW(HWND);
	void CLOSE_WINDOW(HWND);
	void DISABLEWINDOW(HWND , int state);
	void WINDOWCOLOR(HWND , int BGR_color);
	void SETWINDOWTOP(HWND , int State);
	void HIDEWINDOW(HWND , int state);
	void WINDOWBOUNDS(HWND , int MinimalWidth , int MinimalHeight, int MaximalWidth, int MaximalHeight);
	void RESIZEWINDOW(HWND ,  int x = FB_IGNORE, int y = FB_IGNORE, int w = FB_IGNORE, int h = FB_IGNORE);
	int WINDOWX(HWND);
	int WINDOWY(HWND);
	int WINDOWWIDTH(HWND);
	int WINDOWHEIGHT(HWND);
	int WINDOWCLIENTHEIGHT(HWND);
	int WINDOWCLIENTWIDTH(HWND);
	fbstring* GETWINDOWTEXT (HWND);
	void SETWINDOWTEXT (HWND , char* sText);
	void USEGADGETLIST(HWND);
	HWND GETCONTAINERFROMWINDOW (HWND );
	void GETWINDOWSCAPTIONBORDERSIZE(HWND , int* iCaption , int* iBorder);
	void* ADDKEYBOARDSHORTCUT(HWND , long Syskey , long Shortcut , long IDevent );
	void DELETEALLKEYBOARDSHORTCUT(HWND);
	void SETOPTIONSWINDOWSCROLL (int iParam);


	// ---------------------------------------dialogs
	int MESSBOX(fbstring* sCaption , fbstring* sText , int flag = MB_OK, HWND ParentWin = 0);
	int COLORREQUESTER(int iBgrColor = 0, int iFlag = 0, HWND hWin = 0);
	fbstring* NEXTSELECTEDFILENAME();
	fbstring* OPENFILEREQUESTER(fbstring* sTitle , fbstring* sCurDir , fbstring* sPattern , int iFlag , fbstring* sTemplateFileName ,  HWND hParentWin = 0);
	fbstring* SAVEFILEREQUESTER(fbstring* sTitle , fbstring* sCurDir , fbstring* sPattern , int iDefaultSetPattern , fbstring* sTemplateFileName ,  HWND hParentWin = 0);
	fbstring* INPUTBOX(fbstring* sCaption , fbstring* sMessageText , fbstring* sDefaultText , int iFlag = 0 , int iFlag2 = 0  , HWND hParentWin = 0);
	long FONTREQUESTER(HWND hwnd = 0, long nColor = 0);


	//----------------------------------------menu
	HMENU CREATE_MENU();
	HMENU MENUTITLE(HMENU menu, fbstring* sTitle);
	HMENU MENUITEM(int iNumberMenu , HMENU titleMenu , fbstring* sTitle , int iFlag = 0);
	HMENU INSERT_MENU(int iNumberMenu , HMENU titleMenu , fbstring* sTitle , int iNumberSpace , int iFlag = 0);
	HMENU MENUBAR(HMENU titleMenu);
	void CREATEICONITEMMENU (HMENU titleMenu , int iNumberMenu ,HBITMAP IDimage);
	void DELETEITEMMENU ( HMENU menu , int iNumberMenu , int iFlag = 0);
	void DELETE_MENU ( HMENU menu );
	void MENUBACKCOLOR( HMENU menu , int iColor , int iFlag = 0);
	HMENU OPENSUBMENU(HMENU titleMenu , fbstring* sTitle );
	HMENU CREATEPOPMENU();
	void DISPLAYPOPUPMENU(HMENU menu , int iXpos = FB_IGNORE, int iYpos = FB_IGNORE ,HWND hwnd = 0 , int iFlag = 0 );
	fbstring* GETMENUITEMTEXT (HMENU menu , int iNumberMenu );
	void MODIFY_MENU (int iNumberMenu , HMENU menu , fbstring* sTitle , int iNewNumber = FB_IGNORE, int iFlag = 0);
	void HIDEMENU(HMENU menu , int iState);
	void SETSTATEMENU(HMENU menu , int iNumberMenu , int iState);
	int GETSTATEMENU(HMENU menu , int iNumberMenu);


	//----------------------------------------SysTray
	long ADDSYSTRAYICON(long iNumberSysTray , HWND hwnd , HBITMAP hIcon , fbstring* sTooltip);
	void REPLACESYSTRAYICON(long iNumberSysTray , HBITMAP hIcon , fbstring* sTooltip);
	void DELETESYSTRAYICON(long iNumberSysTray);

	//----------------------------------------gadgets
	HWND BUTTONGADGET( int iGadget , int x , int y , int width_ , int height_ , fbstring* sText , int style = 0);
	HWND BUTTONIMAGEGADGET( int iGadget , int x , int y , int width_ , int height_ , HBITMAP image = 0 , int style = 0);
	HWND IMAGEGADGET( int iGadget , int x , int y , int width_ , int height , HBITMAP pImage = 0 , int style1 = 0, int style2 = 0);
	HWND TEXTGADGET(int iGadget , int x , int y , int width_ , int height_ , fbstring* sText , int style = SS_NOTIFY);
	HWND STRINGGADGET(int iGadget , int x , int y , int width_ , int height_ , fbstring* sText , int style = 0 , int style2 = 0);
	HWND SPINGADGET(int iGadget , int x, int y, int width_, int height_, int maxvalue , int minvalue , int curvalue , int style1 = 0 , int style2 = 0 );
	HWND CHECKBOXGADGET( int iGadget , int x, int y, int width_, int height_  , fbstring* sText,  int style = 0 );
	HWND OPTIONGADGET( int iGadget , int x, int y, int width_, int height_ , fbstring* sText, int style = 0 );
	HWND HYPERLINKGADGET( int iGadget , int x, int y, int width_, int height_  , fbstring* sTextLink);
	HWND GROUPGADGET( int iGadget , int iX , int iY , int iWidth , int iHeight , fbstring* sText);
	HWND CONTAINERGADGET(int iGadget , int x , int y , int width_ , int height_ , int iStyle = 0 );


	//statusbar
	void TOOLTIPSTATUSBAR(int iGadget , int iField , fbstring* sText);
	HWND SETSTATUSBARFIELD (int iGadget , int iNfield , int iWidth , fbstring* sText);
	HWND STATUSBARGADGET(int iGadget , fbstring* sText , int iStyle1 = 0, int iStyle2 = 0);

	//combobox
	HWND COMBOBOXGADGET( int iGadget , int x, int y, int width_, int height_  , int iStyle = 0 );
	HWND COMBOBOXIMAGEGADGET( int iGadget , int x, int y, int width_, int height_  , int iSizeIcon = 0, int iStyle = 0 );
	void ADDCOMBOBOXIMAGEITEM( int iGadget ,  fbstring* sText , HBITMAP image , int item = -1 );
	void ADDCOMBOBOXITEM( int iGadget , fbstring* sText , int item = -1 );
	int COUNTITEMCOMBOBOX (int iGadget);
	void DELETECOMBOBOXITEM(int iGadget , int item);
	int FINDITEMCOMBOBOX(int iGadget, fbstring* sFindString , int iStartPos =-1 );
	fbstring* GETCOMBOBOXTEXT(int iGadget, int iItem );
	int GETITEMCOMBOBOX (int iGadget);
	void SETITEMCOMBOBOX (int iGadget , int iItem);
	int LENITEMTEXTCOMBOBOX(int iGadget, int iItem );
	void RESETALLCOMBOBOX( int iGadget);
	void SHOWLISTCOMBOBOX(int iGadget, int iState );
	void FILECOMBOBOXITEM(int iGadget, fbstring* sDirPlusMask , int iAttribut = FBNORMAL | FBDIRECTORY);
	void SETCOMBOBOXITEMTEXT(int iGadget, fbstring* sText , int iItem );

	// ListBox
	HWND LISTBOXGADGET( int iGadget , int x, int y, int width_, int height_  , int iStyle = 0  , int iStyle2 = 0 );
	void SETSELECTMANYITEM( int iGadget , int iStart , int iFinish , int iFlag = 1);
	int GETSELCOUNTLISTBOX (int iGadget , int* iArray = 0 );
	void SETITEMLISTBOX(int iGadget , int iItem);
	int GETITEMLISTBOX(int iGadget);
	int LENITEMTEXTLISTBOX (int iGadget , int iItem);
	fbstring* GETLISTBOXTEXT(int iGadget , int iItem);
	int GETTOPINDEXLISTBOX(int iGadget);
	void SETTOPINDEXLISTBOX( int iGadget , int iItem);
	int FINDITEMLISTBOX( int iGadget , fbstring* sFindString , int iStartPos = -1);
	void FILELISTBOXITEM(int iGadget, fbstring* sDirPlusMask, int iAttribut = FBNORMAL | FBDIRECTORY);
	void RESETALLLISTBOX(int iGadget);
	void DELETELISTBOXITEM(int iGadget , int iItem);
	int COUNTITEMLISTBOX(int iGadget);
	void ADDLISTBOXITEM( int iGadget , fbstring* sText , int iItem = -1 );
	void SETLISTBOXITEMTEXT(int iGadget , fbstring* sText, int iItem);

	// ListView
	HWND LISTVIEWGADGET(int iGadget , int iX , int iY , int iWidth , int iHeight , int iExStyle = 0 , int iStyle = 0 , int iStyle2 = 0 , int iSizeIcon = 0 , int iStyleIcon = 0);
	int FLAGKEYLISTVIEW(int iState = -1);
	int GETCOLUMNLISTVIEW();
	int GETSUBITEMLISTVIEW();
	int GETITEMLISTVIEW();
	void DELETELISTVIEWCOLUMN(int iGadget , int iIndex);
	int ADDLISTVIEWCOLUMN(int iGadget, fbstring* sText , int iPos , int iSubItem , int iWidthColumn = 0 , int iStyleColumnTEXT = 0 , long iStyleMask = 0);
	int ADDLISTVIEWITEM( int iGadget, fbstring* sText , HBITMAP IDImage , int iPos , int iSubItem , int iMaskItem = LVIF_TEXT | LVIF_IMAGE);
	void UPDATEITEM(int iGadget , int iItem );
	int GETITEMCOUNTLISTVIEW(int iGadget);
	void SETSELECTLISTVIEWITEM( int iGadget , int iItem);
	void DELETEITEMLISTVIEW(int iGadget , int iItem);
	void DELETELISTVIEWITEMSALL( int iGadget);
	int GETCOLUMNWIDTHLISTVIEW(int iGadget , int iIndex);
	void SETCOLUMNWIDTHLISTVIEW(int iGadget , int iIndex , int iWidth , int iFlag = 0);
	int GETSELECTEDCOUNTLISTVIEW(int iGadget , int* iArray = 0 );
	int GETSELECTEDLISTVIEWITEM(int iGadget , int iItem , int iMask = 0 );
	fbstring* GETTEXTITEMLISTVIEW( int iGadget, int iItem , int iSubItem);
	void SETTEXTITEMLISTVIEW( int iGadget, int iItem , int iSubItem , fbstring* sText);
	void REPLACEIMAGELISTVIEW( int iGadget, int iItem , int iSubItem , HBITMAP IDimage);
	void SETTEXTCOLUMNLISTVIEW(int iGadget , int iIndex , fbstring* sText);


	// TreeView
	HWND TREEVIEWGADGET(int iGadget , int iX , int iY , int iWidth , int iHeight , int iStyle = 0 , int iStyle2 = 0, int iSizeIcon = 0);
	long ADDTREEVIEWITEM(int iGadget, fbstring* sText , HBITMAP IDImage, HBITMAP IDImageSelect , long iPos , long iParent = 0);
	void DELETETREEVIEWITEM(int iGadget , long iItem );
	int GETCOUNTITEMTREEVIEW(int iGadget);
	int GETINDEXIMAGETREEVIEW(int iGadget , int iItem , int iFlag = 0); 
	long GETITEMTREEVIEW(int iGadget);
	fbstring* GETTEXTTREEVIEW(int iGadget , long iItem);
	long MOVEITEMTREEVIEW(int iGadget, long iCurentPos , long iEndPos , long iParent );
	void SETTEXTITEMTREEVIEW(int iGadget , long iItem , fbstring* sText);
	void REPLACEIMAGEITEMTREEVIEW( int iGadget , long iItem , HBITMAP IDImage = 0 , HBITMAP IDImageSelect = 0 );
	void SETSELECTTREEVIEWITEM(int iGadget  , long iPos );
	long GETPARENTITEMTREEVIEW(int iGadget , long iItem);
	long GETCHILDITEMTREEVIEW(int iGadget , long iItem);
	long GETNEXTITEMTREEVIEW(int iGadget , long iItem);
	long GETPREVITEMTREEVIEW(int iGadget , long iItem);
	long GETFIRSTITEMTREEVIEW(int iGadget);
	void DELETETREEVIEWITEMALL(int iGadget);
	void EXPANDTREEVIEWITEM(int iGadget , long iItem , long iFlagAll);
	void COLLAPSETREEVIEWITEM(int iGadget  , long iItem);
	void EXPANDTREEVIEWITEMALL(int iGadget);
	void COLLAPSETREEVIEWITEMALL(int iGadget);

	// TrackBar
	HWND TRACKBARGADGET( int iGadget , int x, int y, int width_, int height_ , int iMin , int iMax , int iStyle = TBS_HORZ );
	int GETTRACKBARPOS(int iGadget);
	void SETTRACKBARPOS(int iGadget , int iValue);
	void SETTRACKBARMAXPOS(int iGadget , int iMaxPos , int iFlag = 0);
	void SETTRACKBARMINPOS(int iGadget , int iMaxPos , int iFlag = 0);

	//calendar
	HWND CALENDARGADGET(int iGadget , int x, int y, int width_, int height_  , int style = 0 );
	int GETSTATECALENDAR(int iGadget , char bFlag = 5);
	void SETSTATECALENDAR(int iGadget, int iYear , int iMonth , int iDay); 

	//editor
	HWND EDITORGADGET( int iGadget , int x , int y , int width_ , int height_ , fbstring* sText , int style = 0 , int tag = 0);
	void READONLYEDITOR(int iGadget , int flag); 
	void SETTRANSFERTEXTLINEEDITORGADGET(int iGadget , int state = 0);
	int GETLINECOUNTEDITOR(int iGadget);
	void PASTEEDITOR( int iGadget , fbstring* sText , long param = -1);
	fbstring* GETSELECTTEXTEDITORGADGET(int iGadget);
	void SETSELECTTEXTEDITORGADGET(int iGadget , int iBegin , int iEnd);
	int GETCURRENTINDEXCHAREDITOR(int iGadget);
	fbstring* GETLINETEXTEDITOR(int iGadget , int iLine , int iSizeBuffer = 512);
	int GETMODIFYEDITOR(int iGadget);
	void SETMODIFYEDITOR(int iGadget , int iFlag = 0);
	int LINEFROMCHAREDITOR(int iGadget , int iIndex = -1);
	long GETFIRSTVISIBLELINEEDITOR(int gadget);
	long LINESCROLLEDITOR(int gadget, long numberLineScroll);
	void SETTABSTOPSEDITOR(int gadget, long TabWidth = 0);
	long LINELENGTHEDITOR( int gadget , long index = -1);
	long LINEINDEXEDITOR( int gadget , long NumberLine = -1);

	//ProgressBar
	HWND PROGRESSBARGADGET( int iGadget , int x, int y, int width_, int height_  , int iBeginPos = 0 , int iEndPos = 0 , int iStyle = PBS_MARQUEE);
	void SETRANGEPROGRESSBAR(int iGadget , int iBeginPos , int iEndPos);

	//WebGadget
	HWND WEBGADGET(int iGadget , int x , int y , int width_ , int height_ , fbstring* sTextUrl , int style = 0 , int tag = 0);
	void WEBGADGETNAVIGATE(HWND pBrowser, fbstring* sUrl);
	void WEBGADGETSETBODY(HWND pBrowser , fbstring* sHtml);
	void WEBGADGETREFRESH(HWND pBrowser);
	fbstring* WEBGADGETGETURL(HWND pBrowser);
	int WEBGADGETSTATE(HWND pBrowser);
	void WEBGADGETGOBACK(HWND pBrowser);
	void WEBGADGETGOFORWARD(HWND pBrowser);
	fbstring* WEBGADGETGETBODY(HWND pBrowser , int iFlag = 0);

	//PanelGadget
	HWND PANELGADGET(int iGadget , int x , int y , int iWidth = 0, int iHeight = 0, int iSizeIcon = 0 , int iStyle = 0);
	HWND ADDPANELGADGETITEM(int iGadget , int iItem , fbstring* sText , HBITMAP IDImage = 0 , int iFlag = 0 );
	void  PANELGADGETSETCURSEL( int iGadget , int iItem);
	int  PANELGADGETGETCURSEL( int iGadget);
	void DELETEITEMPANELGADGET(int iGadget , int iItem);

	//ScrollBarGadget
	HWND SCROLLBARGADGET(int iGadget , int iX , int iY , int iWidth , int iHeight , int iMinValue , int iMaxValue , int iStyle = SBS_HORZ , int iLenStep = 10);
	int GETSCROLLGADGETPOS(int iGadget);
	void SETSCROLLGADGETPOS(int iGadget , int iPos);
	int GETSCROLLGADGETRANGE(int iGadget , int iFlag);
	void SETSCROLLGADGETRANGE(int iGadget , int iMinValue , int iMaxValue);
	void SETSCROLLGADGETPAGE(int iGadget , int iSizePage);
	void SETPAGESTEPSCROLLBAR(int iGadget , int iSizeStepPage);
	void SHOWSCROLLBAR(int iGadget , int iFlag);

	//GadgetToolTip
	long GADGETTOOLTIP(int iGadgetParent , fbstring* sText , int iGadget = 0);
	void DISABLETOOLTIP(int iGadget , int iState);
	void DELTOOLTIP(int iGadgetParent , int iGadget);
	void SETTOOLTIPTEXT(int iGadgetParent , int iGadget , fbstring* sText);
	fbstring* GETTOOLTIPTEXT(int iGadgetParent , int iGadget);

	//#include "GL/gl.bi"

	//#include "GL/glu.bi"

	//OpenGLGadget
	HWND OPENGLGADGET(int iGadget , int iX , int iY , int iWidth , int iHeight , int cBits = 0 , int dBits = 0 , int sBits = 0 , int aBits = 0);
	void OPENGLGADGETSWAPBUFFERS(int iGadget);
	void OPENGLGADGETMAKECURRENT(int iGadget);

	void RESIZEGADGET(int iGadget ,  int x = FB_IGNORE, int y = FB_IGNORE, int width_ = FB_IGNORE , int height = FB_IGNORE);
	HWND GADGETID(long iGadget);
	int ID_IN_NUMBER(HWND hWin);
	int GETCLASSGADGET(long iGadget);
	void FREEGADGET(int iGadget);
	void SETGADGETCOLOR(int iGadget , int ColorBG , int ColorText , int iFlag); 
	int GETGADGETCOLOR(int iGadget , int iFlag);
	void SETIMAGEGADGET(int iGadget , HBITMAP pImage); 
	#define SETICONGADGET SETIMAGEGADGET;
	int GADGETHEIGHT(int iGadget);
	int GADGETWIDTH(int iGadget);
	int GADGETX(int iGadget);
	int GADGETY(int iGadget);
	void SETGADGETSTATE(int iGadget , int iState);
	int GETGADGETSTATE(int iGadget);
	fbstring* GETGADGETTEXT(int iGadget);
	void SETGADGETTEXT(int iGadget , fbstring* sText);
	void DISABLEGADGET( int iGadget , int iState);
	void HIDEGADGET(int iGadget , int iState);
	void SETGADGETFONT(int iGadget = 0 , long iFont = 0);
	void FREEFONT(long iFont);
	long LOADFONT(fbstring* sName , int iSize , int iCorner = 0 , int iBOLD = 0 , int iItalic = 0 , int iUnderline = 0 , int iStrikeOut = 0);
	char SELECTEDFONTSTYLE(char iStyle);
	int SELECTEDFONTSIZE();
	fbstring* SELECTEDFONTNAME();


	//----------------------------------------ToolBar
	void TOOLBARTOOLTIP(HWND hw, long iButtonID , fbstring* sToolTipS);
	long CREATETOOLBAR(int iStyle1 = IDB_STD_SMALL_COLOR , int iStyle2 = 0 , int iStyle3 = 0 );
	void* TOOLBARSEPARATOR(long iHwndToolBar , long iPositionButton = -1 , int iFlagDrawSeparator = 1);
	long TOOLBARSTANDARDBUTTON(long iHwndToolBar , long iButtonID , long iIndexImage , fbstring* sString,
		long iPositionButton = -1 , long iStyle = TBSTATE_ENABLED , long iStyle2 = 0);
	int COUNTBUTTONTOOLBAR(long iHwndToolBar);
	void DELETEBUTTONTOOLBAR(long iHwndToolBar , int iIndex);
	void DELETETOOLBAR(long iHwndToolBar);
	void SETBUTTONTOOLBARSTATE(long iHwndToolBar , long IDButton , int iFlag , int iState);
	int GETBUTTONTOOLBARSTATE(long iHwndToolBar , long IDButton , int iFlag);
	fbstring* GETTOOLBARTEXTBUTTON ( long iHwndToolBar , long IDButton);
	long TOOLBARIMAGEBUTTON(long iHwndToolBar , long iButtonID , HBITMAP idImage , fbstring* sString, 
		long iPositionButton = -1 , long iStyle  = TBSTATE_ENABLED , long iStyle2 = 0 , int iSizeIcon = 16);


	//----------------------------------------2DDraw
	HDC IMAGESTARTDRAW(HBITMAP);
	HDC WINDOWSTARTDRAW(HWND Hwnd, int iX = 0 , int iY = 0 , int iWidth = 0 , int iHeight = 0 , int iAlpha_Flag = 0 , int iAlpha_Value = 0);
	long STOPDRAW();
	void PIXDRAW( int iX , int iY , int iColor);
	int BOXDRAW(int iX , int iY , int iWidth , int iHeight , int iColorPen = 0, int iColorBG = 0 , int iWidthPen = 1 , int iStylePen = PS_SOLID , int iAlpha = 255);
	int POLYGONDRAW(GdkPoint* pPoint , int iNCount , int iFillColor = 0 , int iBorderColor = 0 , int iBorderWidth = 1 , int iBorderStyle = PS_SOLID);
	int POLYLINEDRAW(GdkPoint* pPoint , int iNCount , int iColorPen = 0 , int iWidthPen = 1 , int iStylePen = PS_SOLID);
	int LINEDRAW(int IX , int IY , int iX1 , int iY1 , int iWidthPen = 1 , int iColor = 0 , int iStylePen = PS_SOLID);
	int  CIRCLEDRAW(int IX , int IY , int iRadius , int iColorPen = 0 , int iColorBG = 0 , int iWidthPen = 1 , int iStylePen = PS_SOLID , int iAlpha = 255);
	int IMAGEDRAW( HBITMAP pImg , int IX , int IY , int iAlpha = 255);
	unsigned int GETPIX( int IX , int IY);
	void FILLRECTDRAW( int iX ,  int IY , int iColor);
	void FOCUSDRAW( int IX , int IY , int iWidth , int iHeight , int iColor = 0);
	int  ROUNDDRAW(int IX , int IY , int iWidth , int iHeight , int iColorPen = 0, int iColorBG = 0 , int iWidthPen = 1 , int iStylePen = PS_SOLID , int iAlpha = 255);
	int  GRADIENTFILLDRAW(int IX , int IY , int iWidth , int iHeight , int Rbegin , int Gbegin , int Bbegin , int REnd , int GEnd , int BEnd , int GOR_VERT = 0);
	int PIEDRAW(int IX , int IY , int iWidth , int iHeight , int iX1 , int iY1 , int iX2 , int iY2 , int iColorPen = 0 , int iColorBG = 0 , int iWidthPen = 1 , int iStylePen = PS_SOLID);
	int TEXTDRAW( int IX , int IY , fbstring* sText , int ColorBK = 0 , int ColorText = 0 , int iAlpha = 255);
	void FONTDRAW(long iFont);


	//----------------------------------------2DDrawA
	void* IMAGESTARTDRAWA(void* & hBit , long  iColorFlag = 0 , long iColor = 0xFFFFFFFF);
	void* WINDOWSTARTDRAWA(HWND hwnd , long x = 0 , long y = 0 , long w = 0 , long h = 0 , long iColorFlag = 0 , long iColor = 0xFFFFFFFF);
	long STOPDRAWA();
	void SETPIXA( int IX , int IY , int iColor = 0xff000000);
	long GETPIXA(float iX , float iY);
	void* CREATEBRUSHA(float x0 = 0 , float y0 = 0 , float x1 = 0 , float y1 = 0,
		long iColor1 = 0xFF00FF00 , long iColor2 = 0xFF0000FF , void* GpImage=0 , long WrapMode = 3 );
	void FREEBRUSHA(void* Brush);
	void BOXDRAWA(float iX , float iY , float iWidth ,
		float iHeight , long iColorPen = 0xff000000 , long iFlagcolorBK = 1 ,
		long iColorBk = 0xff000000 , void* brushPen = 0 , void* brushBk = 0 , float iWidthPen=1);
	void CIRCLEDRAWA(float iX , float iY , float iRadius ,
		long iColorPen = 0xff000000 , long iFlagcolorBK = 1 ,
		long iColorBk = 0xff000000 , void* brushPen = 0,
		void* brushBk = 0 , float iWidthPen = 1);
	void ROUNDDRAWA(float iX , float iY , float iWidth , float iHeight ,
		long iColorPen = 0xff000000 , long iFlagcolorBK = 1 , long iColorBk = 0xff000000 ,
		void* brushPen = 0 , void* brushBk = 0 , float iWidthPen=1);
	void LINEDRAWA(float iX , float iY , float iX1 , float iY1 ,
		float iWidthPen = 1 , long iColorBk = 0xff000000 , void* brushPen = 0);
	void IMAGEDRAWA(void* GpImage , float iX , float iY , float iWidth0 = 0 , float iHeight0 = 0);
	void MODEDRAWA(long mode);
	void FILLRECTDRAWA(long iX , long iY , long iColor);
	void BEZIERDRAWA(float x0 , float y0 , float x1 , float y1,
		float x2 , float y2 , float x3 , float y3 ,
		long iColorPen = 0xff000000 , void* brushPen = 0 , float iWidthPen=1);
	void ARCDRAWA(float iX , float iY , float iWidth , float iHeight ,
		float startAngle , float sweepAngle , long iColorPen = 0xff000000,
		void* brushPen = 0 , float iWidthPen = 1);
	void PIEDRAWA(float iX , float iY , float iWidth , float iHeight,
		float startAngle , float sweepAngle , long iColorPen = 0xff000000,
		long iFlagcolorBK = 1 , long iColorBk = 0xff000000 , void* brushPen = 0,
		void* brushBk = 0 , float iWidthPen = 1);
	void POLYGONDRAWA(void* Points , long iCountPoints , long iColorPen = 0xff000000 ,
		long iFlagcolorBK = 1 , long iColorBk = 0xff000000 , void* brushPen=0 ,
		void* brushBk = 0 , float iWidthPen=1 , long iFillmode =0);
	void* CREATEFONTDRAWA(fbstring* sName , long iSize = 10 , long iStyle = 0 , long iUnit = 6);
	void FREEFONTDRAWA(void* GpFont);
	void TEXTDRAWA(fbstring* sText , long iX , long iY , void* GpFont = 0,
		long iColor = 0xFFFFFFFF , void* brush = 0 , long iMode = 0);


	//----------------------------------------clipboard
	void SETCLIPBOARDTEXT(fbstring* sText);
	fbstring* GETCLIPBOARDTEXT();
	void SETCLIPBOARDIMAGE(HBITMAP bmp);
	HBITMAP GETCLIPBOARDIMAGE();


	//----------------------------------------desktop
	fbstring* GETCURRENTSETTINGSDISPLAY();
	long GETWIDTHDESKTOP(fbstring* setting);
	long GETHEIGHTDESKTOP(fbstring* setting);
	long GETBITSDESKTOP(fbstring* setting);
	long GETFREQUENCYDESKTOP(fbstring* setting);


	//----------------------------------------misc
	fbstring* REPLACESTRING(fbstring* String , fbstring* SearchString , fbstring* ReplaceString , int Position = 1 , int searchParam = 0 , int RegisterParam = 0);
	int INSERTSTRING(fbstring* DestS , fbstring* InsertS , int Position);
	fbstring* CLEARSTRING(fbstring* sText , fbstring* sTrimSimbols);
	fbstring* PEEKS(void* Memory , long iLen = 0);
	void FASTCOPY(void* d , void* s , unsigned long n);
	int SIZEX();
	int SIZEY();
	void SLEEPW9(long n);
	int UBOUNDINCBIN(void* pBuf);
	void UPDATEINFOXSERVER(int iCountCicles = 10000);


	//----------------------------------------events

	int WINDOWEVENT();
	int WAITEVENT();
	int EVENTNUMBER();
	int EVENTNUMBERLISTVIEW();
	HWND EVENTHWND();
	int EVENTKEY();
	int EVENTHARDWAREKEY();
	void SENDNULLEVENT();


	//----------------------------------------Timers
	void SETTIMER(HWND hwnd , int & idTimer , int iElapse , void* pTimerProc);
	void KILLTIMER (HWND hwnd , int idTimer);


	//----------------------------------------Image
	HBITMAP LOAD_IMAGE(fbstring* sPath , int iColorBack = 0); 
	#define LOAD_ICON LOAD_IMAGE;
	int IMAGE_WIDTH (HBITMAP pImage);
	int IMAGE_HEIGHT(HBITMAP pImage);
	HBITMAP COPY_IMAGE(HBITMAP pImage);
	HBITMAP GRAB_IMAGE(HBITMAP pImage , int IX , int IY , int iWidth , int iHeght);
	HBITMAP CREATE_IMAGE(int iWidth , int iHeght);
	HBITMAP CATCH_IMAGE(void* pBuf , int iColor = 0);
	void SAVE_IMAGE(fbstring* pImage, fbstring* sPath);
	void FREE_IMAGE(HBITMAP pImage);
	HBITMAP RESIZE_IMAGE(HBITMAP pImage , int iWidth , int iHeght);
	HBITMAP ROTATE4_IMAGE(HBITMAP pImage , int iFlag);
	HBITMAP CREATECOPYIMAGEDESKTOP();
	HBITMAP CREATECOPYIMAGERECT(void* hWin , int IX, int IY, int iWidth, int iHeight , int iFlag = 0);
	HBITMAP CREATECOPYIMAGEWINDOW(void* hWin , int iFlag = 0);
	HBITMAP CREATECOPYIMAGEWINDOWCLIENT(void* hWin , int iFlag = 0);
	void ROTATEANDSCALEIMAGE(HBITMAP sourcehBmp , HBITMAP & hbmpDest, long X ,
		long Y , long Xr , long Yr , float angle ,
		float Xscale = 0 , float Yscale = 0 , long iColor = 0 , HBITMAP BGbitmap = 0);


	//----------------------------------------ImageA
	void* CREATEGPBITMAPFROMHBITMAP(HBITMAP hBmp);
	HBITMAP CREATEHBITMAPFROMGPBITMAP(void* GpBitmap , long BackColor = 0xf0f0f0);
	void* COPY_IMAGEA(void* GpImage);
	void* CATCH_IMAGEA(unsigned char* array);
	void* GRAB_IMAGEA(void* GpImage , float iX , float iY  , float & iWidth , float & iHeight);
	long IMAGE_HEIGHTA(void* GpImage);
	long IMAGE_WIDTHA(void* GpImage);
	void RESIZE_IMAGEA(void* & GpImage , float & iWidth , float & iHeight);
	void* CREATE_IMAGEA(int iWidth , int iHeight);
	long SAVE_IMAGEA(void* GpImage, fbstring* sFileName);
	void ROTATEANDSCALEIMAGEA(void* GpbitmapSource , HBITMAP & hbmpDest,
		long X , long Y , long Xr , long Yr,
		float angle , float Xscale = 0 , float Yscale = 0,
		long iColor = 0 , void* BGbitmap = 0);
	void* LOAD_IMAGEA(fbstring* sFileName);
	void FREE_IMAGEA(void* GpBitmap);


	//----------------------------------------File
	HANDLE OPEN_FILE(fbstring* sFileName , int flag = 0); 
	HANDLE CREATE_FILE(fbstring* sFileName , int flag = 0);
	HANDLE READ_FILE(fbstring* sFileName , int flag = 0);
	void WRITE_STRING(HANDLE fp , fbstring* s);
	void WRITE_STRINGN(HANDLE fp , fbstring* s);
	void CLOSE_FILE(HANDLE fp);
	void SET_FILE_POINTER(HANDLE fp , int position , int method = FILE_CURRENT);
	long GET_FILE_POINTER(HANDLE fp);
	int E_O_F(HANDLE fp);
	long SIZE_FILE(HANDLE fp);
	fbstring* READ_STRING(HANDLE fp);
	fbstring* READ_CHARACTER(HANDLE fp);
	char READ_BYTE(HANDLE fp);
	short int READ_WORD(HANDLE fp);
	int READ_INTEGER(HANDLE fp);
	long READ_LONGINT(HANDLE fp);
	float READ_SINGLE(HANDLE fp);
	double READ_DOUBLE(HANDLE fp);
	void READ_DATA(HANDLE fp , void* pMem , int lenght);
	void* READ_DATAA(HANDLE fp , int iLenght);
	void* READ_DATAS(HANDLE fp , int iLenght);
	void WRITE_CHARACTER(HANDLE fp , fbstring* charaster);
	void WRITE_BYTE(HANDLE fp , char bValue);
	void WRITE_LONGINT(HANDLE fp , long llValue);
	void WRITE_INTEGER(HANDLE fp , int iValue);
	void WRITE_WORD(HANDLE fp , short int shValue);
	void WRITE_SINGLE(HANDLE fp , float siValue);
	void WRITE_DOUBLE(HANDLE fp , double dValue);
	void WRITE_DATA(HANDLE fp , void* Buf , int Lenght);


	//----------------------------------------FileSystem
	fbstring* GETPATHPART(fbstring* sPath);
	fbstring* GETEXTENSIONPART(fbstring* sPath);
	fbstring* GETFILEPART(fbstring* sPath);
	void DELETEDIR(fbstring* sDelDir , int iFlag = 0); 
	#define REMOVEDIR DELETEDIR;
	void MOVEDIR(fbstring* sMoveOutDir , fbstring* sMoveInDir , int iFlag = 0);
	fbstring* GETCURENTDIR();
	void DELETE_FILE(fbstring* sFile);
	void COPYDIR(fbstring* sSourceDir , fbstring* sDestDir , int iFlag = 0);
	void CREATEDIR(fbstring* sDir);
	void SETCURENTDIR(fbstring* sCurDir);
	void RENAMEDIR(fbstring* sOldName , fbstring* sNewName , int iFlag = 0);
	long EXAMINEDIRECTORY(fbstring* sDirectoryName , fbstring* sPattern);
	unsigned int DIRECTORYENTRYATTRIBUTES(long hDir);
	long NEXTDIRECTORYENTRY(long hDir);
	void FINISHDIRECTORY(long hDir);
	fbstring* DIRECTORYENTRYNAME(long hDir);
	unsigned long DIRECTORYENTRYSIZE(long hDir);
	fbstring* DIRECTORYENTRYDATE(long hDir , int iFlag);


	//----------------------------------------Encode\Decode
	fbstring* AESENCODER(fbstring* Text, fbstring* Key);
	fbstring* AESDECODER(fbstring* Text, fbstring* Key);
	fbstring* ENCODE64(fbstring* bs64);
	fbstring* DECODE64(fbstring* str_b64);
	unsigned int FASTCRC32(void* pAnyBuffer , unsigned int BufferSize);
	fbstring* MD5CREATEFILEHASH(fbstring* fileName);
	fbstring* MD5CREATEHASH(fbstring* Text);
	fbstring* SHA1CREATE(fbstring* Text);
	fbstring* SHA1CREATEFILE(fbstring* sFile);
	fbstring* SHA512CREATEFILE(fbstring* sFile);
	fbstring* SHA512CREATE(fbstring* Text);


	//----------------------------------------Mouse
	int ISMOUSEOVER(HWND hWin);
	int GLOBALMOUSEY();
	int GLOBALMOUSEX();
	int MOUSEX();
	int MOUSEY();


	//----------------------------------------Preference
	HANDLE CREATEFBINI(fbstring* filename);
	HANDLE OPENFBINI(fbstring* filename , char flag = 0);
	char CLOSEFBINI();
	void WRITEGROUPFBINI(fbstring* group);
	void _Z15WRITEVALUEFBINIR8FBSTRINGS0_a( fbstring* GROUP, fbstring* KEY, char VALUE);
	#define WRITEVALUEFBINI_BYTE _Z15WRITEVALUEFBINIR8FBSTRINGS0_a;
	void _Z15WRITEVALUEFBINIR8FBSTRINGS0_s( fbstring* GROUP, fbstring* KEY, signed int VALUE);
	#define WRITEVALUEFBINI_SHORT _Z15WRITEVALUEFBINIR8FBSTRINGS0_s;
	void _Z15WRITEVALUEFBINIR8FBSTRINGS0_i( fbstring* GROUP, fbstring* KEY, int VALUE);
	#define WRITEVALUEFBINI_INTEGER _Z15WRITEVALUEFBINIR8FBSTRINGS0_i;
	void _Z15WRITEVALUEFBINIR8FBSTRINGS0_x( fbstring* GROUP, fbstring* KEY, long VALUE);
	#define WRITEVALUEFBINI_LONGINT _Z15WRITEVALUEFBINIR8FBSTRINGS0_x;
	void _Z15WRITEVALUEFBINIR8FBSTRINGS0_d( fbstring* GROUP, fbstring* KEY, double VALUE);
	#define WRITEVALUEFBINI_DOUBLE _Z15WRITEVALUEFBINIR8FBSTRINGS0_d;
	void _Z15WRITEVALUEFBINIR8FBSTRINGS0_S0_( fbstring* GROUP, fbstring* KEY, fbstring* VALUE);
	#define WRITEVALUEFBINI_STRING _Z15WRITEVALUEFBINIR8FBSTRINGS0_S0_;
	char READBYTEVALUEFBINI(fbstring* group , fbstring* Key);
	short int READSHORTVALUEFBINI(fbstring* group , fbstring* Key);
	int READINTEGERVALUEFBINI(fbstring* group , fbstring* Key);
	long READLONGINTVALUEFBINI(fbstring* group , fbstring* Key);
	double READDOUBLEVALUEFBINI(fbstring* group , fbstring* Key);
	fbstring* READSTRINGVALUEFBINI(fbstring* group , fbstring* Key);


	//----------------------------------------Process
	long RUNPROGRAM(fbstring* sFilename , fbstring* sParameter , fbstring* sWorkingDirectory , fbstring* sFlags , long ShowCmd = 0);
	void KILLPROCESS( long iPID , long iExitCode = 9);
	fbstring* GETNAMEPROCESS();
	fbstring* GETFULLCOMMANDPROCESS();
	long GETIDPROCESS();
	HANDLE INITPROCESS();
	void CLOSEHANDLE(HANDLE pDir);
	int FIRSTPROCESS(HANDLE pDir);
	int NEXTPROCESS(HANDLE pDir);

	//----------------------------------------Compress
	int COMPRESSMEM(char* & BUF_DEST , char* SOURSEDATA , unsigned int SIZEDATA , unsigned int level = 5);
	int DECOMPRESSMEM(char* & BUF_COMPRESSED , int SIZECOMPRESSED , char* & BUFDESTDATA);
	int COMPRESSFILE(fbstring* filename , fbstring* filenameDest , int level = 5);
	int DECOMPRESSFILE(fbstring* filename , fbstring* filenameDest);
};
